
# spec file
#
# Copyright (c) 2022 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global flavor gnu-hpc%{nil}
%ifarch s390 i586
ExclusiveArch:  do_not_build
%endif

%if 0%{?sle_version} >= 150200
%define DisOMPI1 ExclusiveArch:  do_not_build
%endif
%if !0%{?is_opensuse} && 0%{?sle_version:1} && 0%{?sle_version} < 150200
%define DisOMPI3 ExclusiveArch:  do_not_build
%endif

%if 0%{?sle_version:1} && 0%{?sle_version} < 150300
%define DisOMPI4 ExclusiveArch:  do_not_build
%endif

# Disable until resource issue is resolved.
%bcond_with check

%define use_sz2 0

%define vers 1.10.11
%define _vers 1_10_11
%define short_ver 1.10
%define src_ver %{version}
%define pname hdf5
%global _lto_cflags %{_lto_cflags} -ffat-lto-objects

%if "%{flavor}" == ""
ExclusiveArch:  do_not_build
 %define package_name %pname
%endif

%if "%{flavor}" == "serial"
%bcond_with hpc
%endif

%if "%{flavor}" == "openmpi1"
%{?DisOMPI1}
%global mpi_flavor openmpi
%define mpi_vers 1
%bcond_with hpc
%endif

%if "%{flavor}" == "openmpi2"
%{?DisOMPI2}
%global mpi_flavor openmpi
%define mpi_vers 2
%bcond_with hpc
%endif

%if "%{flavor}" == "openmpi3"
%{?DisOMPI3}
%global mpi_flavor openmpi
%define mpi_vers 3
%bcond_with hpc
%endif

%if "%{flavor}" == "openmpi4"
%{?DisOMPI4}
%global mpi_flavor openmpi
%define mpi_vers 4
%bcond_with hpc
%endif

%if "%{flavor}" == "mvapich2"
%global mpi_flavor %{flavor}
%bcond_with hpc
%endif

%if "%{flavor}" == "gnu-hpc"
%bcond_without hpc
%global compiler_family gnu
%undefine c_f_ver
%endif

%if "%{flavor}" == "gnu-openmpi-hpc"
%{?DisOMPI1}
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor openmpi
%define mpi_vers 1
%endif

%if "%{flavor}" == "gnu-mvapich2-hpc"
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor mvapich2
%endif

%if "%{flavor}" == "gnu-openmpi2-hpc"
%{?DisOMPI2}
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor openmpi
%define mpi_vers 2
%endif

%if "%{flavor}" == "gnu-openmpi3-hpc"
%{?DisOMPI3}
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor openmpi
%define mpi_vers 3
%endif

%if "%{flavor}" == "gnu-openmpi4-hpc"
%{?DisOMPI4}
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor openmpi
%define mpi_vers 4
%endif

%if "%{flavor}" == "gnu-mpich-hpc"
%bcond_without hpc
%define compiler_family gnu
%undefine c_f_ver
%global mpi_flavor mpich
%endif

%if "%{flavor}" == "gnu7-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%undefine mpi_flavor
%endif

%if "%{flavor}" == "gnu7-openmpi-hpc"
%{?DisOMPI1}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor openmpi
%define mpi_vers 1
%endif

%if "%{flavor}" == "gnu7-openmpi2-hpc"
%{?DisOMPI2}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor openmpi
%define mpi_vers 2
%endif

%if "%{flavor}" == "gnu7-mvapich2-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor mvapich2
%endif

%if "%{flavor}" == "gnu7-openmpi3-hpc"
%{?DisOMPI3}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor openmpi
%define mpi_vers 3
%endif

%if "%{flavor}" == "gnu7-openmpi4-hpc"
%{?DisOMPI4}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor openmpi
%define mpi_vers 4
%endif

%if "%{flavor}" == "gnu7-mpich-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 7
%global mpi_flavor mpich
%endif

%if "%{flavor}" == "gnu8-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%undefine mpi_flavor
%endif

%if "%{flavor}" == "gnu8-openmpi-hpc"
%{?DisOMPI1}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor openmpi
%define mpi_vers 1
%endif

%if "%{flavor}" == "gnu8-openmpi2-hpc"
%{?DisOMPI2}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor openmpi
%define mpi_vers 2
%endif

%if "%{flavor}" == "gnu8-openmpi3-hpc"
%{?DisOMPI3}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor openmpi
%define mpi_vers 3
%endif

%if "%{flavor}" == "gnu8-openmpi4-hpc"
%{?DisOMPI4}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor openmpi
%define mpi_vers 4
%endif

%if "%{flavor}" == "gnu8-mvapich2-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor mvapich2
%endif

%if "%{flavor}" == "gnu8-mpich-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 8
%global mpi_flavor mpich
%endif

%if "%{flavor}" == "gnu9-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%undefine mpi_flavor
%endif

%if "%{flavor}" == "gnu9-openmpi-hpc"
%{?DisOMPI1}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor openmpi
%define mpi_vers 1
%endif

%if "%{flavor}" == "gnu9-openmpi2-hpc"
%{?DisOMPI2}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor openmpi
%define mpi_vers 2
%endif

%if "%{flavor}" == "gnu9-openmpi3-hpc"
%{?DisOMPI3}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor openmpi
%define mpi_vers 3
%endif

%if "%{flavor}" == "gnu9-openmpi4-hpc"
%{?DisOMPI4}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor openmpi
%define mpi_vers 4
%endif

%if "%{flavor}" == "gnu9-mvapich2-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor mvapich2
%endif

%if "%{flavor}" == "gnu9-mpich-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 9
%global mpi_flavor mpich
%endif

%if "%{flavor}" == "gnu10-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%undefine mpi_flavor
%endif

%if "%{flavor}" == "gnu10-openmpi-hpc"
%{?DisOMPI1}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor openmpi
%define mpi_vers 1
%endif

%if "%{flavor}" == "gnu10-openmpi2-hpc"
%{?DisOMPI2}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor openmpi
%define mpi_vers 2
%endif

%if "%{flavor}" == "gnu10-openmpi3-hpc"
%{?DisOMPI3}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor openmpi
%define mpi_vers 3
%endif

%if "%{flavor}" == "gnu10-openmpi4-hpc"
%{?DisOMPI4}
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor openmpi
%define mpi_vers 4
%endif

%if "%{flavor}" == "gnu10-mvapich2-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor mvapich2
%endif

%if "%{flavor}" == "gnu10-mpich-hpc"
%bcond_without hpc
%define compiler_family gnu
%define c_f_ver 10
%global mpi_flavor mpich
%endif

%{?mpi_flavor:%{bcond_without mpi}}%{!?mpi_flavor:%{bcond_with mpi}}
%{?with_hpc:%{!?compiler_family:%global compiler_family gnu}}
%{?with_mpi:%{!?mpi_flavor:error "No MPI family specified!"}}

# For compatibility package names
%if "%{flavor}" == "openmpi1" && 0%{?suse_version} <= 1500
%define mpi_ext %{nil}
%else
%define mpi_ext %{?mpi_vers}
%endif

%if %{with hpc}
%{hpc_init -c %compiler_family %{?with_mpi:-m %mpi_flavor} %{?c_f_ver:-v %{c_f_ver}} %{?mpi_vers:-V %{mpi_vers}} %{?ext:-e %{ext}}}
%{?with_mpi:%global hpc_module_pname p%{pname}}
 %define my_prefix %hpc_prefix
 %define my_bindir %hpc_bindir
   %ifarch x86_64
 %define my_libdir %hpc_prefix/lib64
   %else
 %define my_libdir %hpc_libdir
   %endif
 %define my_incdir %hpc_includedir
 %define package_name   %{hpc_package_name %_vers}
 %define libname(l:s:)   lib%{pname}%{-l*}%{hpc_package_name_tail %{?_vers}}
 %define vname %{pname}_%{_vers}-hpc
%else
 %if %{without mpi}
  %define my_prefix %_prefix
  %define my_bindir %_bindir
  %define my_libdir %_libdir
  %define my_incdir %_includedir
 %else
  %define my_prefix %{_libdir}/mpi/gcc/%{mpi_flavor}%{?mpi_ext}
  %define my_suffix -%{mpi_flavor}%{?mpi_ext}
  %define my_bindir %{my_prefix}/bin
  %define my_libdir %{my_prefix}/%{_lib}/
  %define my_incdir %{my_prefix}/include/
 %endif
 %if 0%{!?package_name:1}
  %define package_name   %pname%{?my_suffix}
 %endif
 %define libname(l:s:)   lib%{pname}%{!-l:%{-s:-}}%{-l*}%{-s*}%{?my_suffix}
 %define vname %{pname}
%endif

# Run 'sh ./update_so_version.sh' when updating hdf5!
%include %{_sourcedir}/so_versions

Name:           %{package_name}
Version:        %vers
Release:        150400.3.21.2
Summary:        Command-line programs for the HDF5 scientific data format
License:        BSD-3-Clause
Group:          Productivity/Scientific/Other
URL:            https://www.hdfgroup.org/HDF5/
Source0:        https://www.hdfgroup.org/ftp/HDF5/releases/%{pname}-%{short_ver}/%{pname}-%{src_ver}/src/%{pname}-%{src_ver}.tar.bz2
Source100:      so_versions
Source1000:     update_so_version.sh
Patch0:         hdf5-LD_LIBRARY_PATH.patch
# not really needed but we want to get noticed if hdf5 doesn' t know our host
Patch2:         hdf5-1.8.11-abort_unknown_host_config.patch
%ifarch %arm
Patch4:         hdf5-1.8.10-tests-arm.patch
%endif
Patch5:         PPC64LE-Fix-long-double-handling.patch
Patch6:         hdf5-Remove-timestamps-from-binaries.patch
# Could be ported but it's unknown if it's still needed
Patch8:         Disable-phdf5-tests.patch
# boo#1179521, boo#1196682, gh#HDFGroup/hdf5#1494
# Imported from Fedora, strip flags from h5cc wrapper
Patch10:        hdf5-wrappers.patch
Patch13:        Fix-error-message-not-the-name-but-the-link-information-is-parsed.patch
Patch14:        Make-sure-info-block-for-external-links-has-at-least-3-bytes.patch
Patch16:        H5O_fsinfo_decode-Make-more-resilient-to-out-of-bounds-read.patch
Patch19:        When-evicting-driver-info-block-NULL-the-corresponding-entry.patch
Patch22:        H5IMget_image_info-H5Sget_simple_extent_dims-does-not-exceed-array-size.patch
Patch23:        H5O-patches-partial.patch
Patch24:        Add-H5F-RFIC-boilerplate.patch
Patch25:        Add-H5T_is_numeric_with_unusual_unused_bits.patch
Patch26:        Add-H5_RANGE_OVERLAP.patch
Patch27:        Patch-H5Odtype.c.patch
Patch28:        Patch-H5Tcommit.c.patch
Patch29:        Add-unused-bits-checks-and-tools-patches.patch
Patch30:        Update-overflow-macro.patch
Patch31:        Update-H5_IS_BUFFER_OVERFLOW-to-account-for-size-of-0.patch
Patch32:        Fixes-for-file-format-security-issues.patch
Patch33:        Make-sure-unused-attribute-entries-are-NULLed.patch
Patch34:        Add-sanity-and-overrun-checks-to-H5HG__cache_heap_deserialize.patch
Patch35:        Mark-datatype-as-freed-always.patch
Patch36:        Fix-an-uninitialized-value-warning.patch

BuildRequires:  fdupes
%if 0%{?use_sz2}
BuildRequires:  libsz2-devel
%endif
BuildRequires:  zlib-devel
%if %{without hpc}
BuildRequires:  gcc-c++
BuildRequires:  gcc-fortran
 %if %{with mpi}
BuildRequires:  %{mpi_flavor}%{?mpi_ext}-devel
 %else
Requires:       lib%{pname}_cpp%{sonum_CXX} = %{version}
Requires:       lib%{pname}_hl_cpp%{sonum_HL_CXX} = %{version}
 %endif
Requires:       lib%{pname}-%{sonum} = %{version}
Requires:       lib%{pname}_fortran%{sonum_F} = %{version}
Requires:       lib%{pname}_hl%{sonum_HL} = %{version}
Requires:       lib%{pname}hl_fortran%{sonum_HL_F} = %{version}
%else # hpc
%hpc_requires
Requires:       %{libname -l _fortran}
%if %{without mpi}
Requires:       %{libname -l _cpp}
Requires:       %{libname -l _hl_cpp}
%endif
Requires:       %{libname -l _hl}
Requires:       %{libname -l hl_fortran}
Requires:       %{libname}
BuildRequires:  %{compiler_family}%{?c_f_ver}-compilers-hpc-macros-devel
BuildRequires:  lua-lmod
BuildRequires:  suse-hpc >= 0.2
 %if %{with mpi}
BuildRequires:  %{mpi_flavor}%{?mpi_vers}-%{compiler_family}%{?c_f_ver}-hpc-macros-devel
 %endif
%endif  # ?hpc
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if "%{flavor}" == "openmpi1" && 0%{?suse_version} <= 1500
Provides:       %{pname}-openmpi = %{version}-%{release}
Obsoletes:      %{pname}-openmpi < %{version}-%{release}
%endif

%description
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the %{flavor} version utility functions for working
with HDF5 files.

%{?with_hpc:%{hpc_master_package}}

%package -n     %{libname -s %{sonum}}
Summary:        Shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname} = %{version}
Obsoletes:      %{libname} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -s %{sonum}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the %{flavor} version of the HDF5 runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}%{hpc_package_name_tail}}}

%package -n     %{libname -l _hl -s %{sonum_HL}}
Summary:        High-level shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname -l _hl} = %{version}
Obsoletes:      %{libname -l _hl} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -l _hl -s %{sonum_HL}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the %{flavor} version of the high-level HDF5
runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}_hl%{hpc_package_name_tail} -N %{pname}_hl}}

%package -n     %{libname -l _cpp -s %{sonum_CXX}}
Summary:        Shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname -l _cpp} = %{version}
Obsoletes:      %{libname -l _cpp} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -l _cpp -s %{sonum_CXX}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the HDF5 runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}_cpp%{hpc_package_name_tail} -N %{pname}_cpp}}

%package -n     %{libname -l _hl_cpp -s %{sonum_HL_CXX}}
Summary:        High-level shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname -l _hl_cpp} = %{version}
Obsoletes:      %{libname -l _hl_cpp} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -l _hl_cpp -s %{sonum_HL_CXX}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the the high-level HDF5 runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}_hl_cpp%{hpc_package_name_tail} -N %{pname}_hl_cpp}}

%package -n     %{libname -l _fortran -s %{sonum_F}}
Summary:        Shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname -l _fortran} = %{version}
Obsoletes:      %{libname -l _fortran} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -l _fortran -s %{sonum_F}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the %{flavor} version of the HDF5 runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}_fortran%{hpc_package_name_tail} -N %{pname}_fortran}}

%package -n     %{libname -l hl_fortran -s %{sonum_HL_F}}
Summary:        High-level shared libraries for the HDF5 scientific data format
# To avoid unresolvable errors due to multiple providers of the library
Group:          System/Libraries
Provides:       %{libname -l hl_fortran} = %{version}
Obsoletes:      %{libname -l hl_fortran} < %{version}
%{?with_hpc:Requires:       %{name}-module = %version}

%description -n %{libname -l hl_fortran -s %{sonum_HL_F}}
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the %{flavor} version of the high-level HDF5
runtime libraries.

%{?with_hpc:%{hpc_master_package -l -n lib%{pname}_hl_fortran%{hpc_package_name_tail} -N %{pname}hl_fortran}}

%package -n %{pname}-devel-data
Summary:        Development data files for %{name}
Group:          Development/Libraries/Other

%description -n %{pname}-devel-data
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains generic files needed to create projects that use
any version of HDF5.

%package devel
Summary:        Development files for %{name}
Group:          Development/Libraries/Parallel
Requires:       %{libname -l _cpp -s %{sonum_CXX}} = %{version}
Requires:       %{libname -l _hl_cpp -s %{sonum_HL_CXX}} = %{version}
Requires:       %{name} = %{version}
%{!?with_hpc:Requires:       %{pname}-devel-data = %{version}}
Requires:       zlib-devel
%if 0%{?use_sz2}
Requires:       libsz2-devel
%endif
Requires:       %{libname -s %{sonum}} = %{version}
# Required by Fortran programs?
Requires:       %{libname -l _fortran -s %{sonum_F}} = %{version}
Requires:       %{libname -l _hl -s %{sonum_HL}} = %{version}
Requires:       %{libname -l hl_fortran -s %{sonum_HL_F}} = %{version}
%{?with_hpc:%hpc_requires_devel}
%if "%{flavor}" == "openmpi1" && 0%{?suse_version} <= 1500
Provides:       %{pname}-openmpi-devel = %{version}-%{release}
Obsoletes:      %{pname}-openmpi-devel < %{version}-%{release}
%endif

%description devel
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains all files needed to create projects that use
the %{flavor} version of HDF5.

%{?with_hpc:%{hpc_master_package devel}}

%package  devel-static
Summary:        Static development files for %{name}
Group:          Development/Libraries/Parallel
Requires:       %{name}-devel = %{version}

%description devel-static
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package provides the static libraries for the %{flavor} version of HDF5.

%package -n %{vname}-examples
Summary:        Examples for %{name}
Group:          Documentation/Other

%description -n %{vname}-examples
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package provides examples of HDF5 library use.

%{?!with_mpi:%{?with_hpc:%{hpc_master_package -n %{pname}-hpc-examples -M %{vname}-examples}}}

%if %{with hpc}
%package module
Summary:        Module files for %{name}
Group:          Development/Libraries/Parallel
Provides:       %{name}-module = %version
Requires:       lua-lmod

%description module
HDF5 is a data model, library, and file format for storing and
managing data. It supports an unlimited variety of datatypes.

This package contains the environment module needed for the HDF5
library packages.
%endif

%prep
%{?with_hpc: %hpc_debug}
%setup -q -n %{pname}-%{version}
##%patch0 -p1 -b .LD_LIBRARY_PATH
%patch2 -p0 -b .abort_unknown_host_config
%ifarch %arm
%patch4 -p0 -b .tests-arm
%endif
%patch5 -p1
%patch6 -p1
%patch8 -p1
%patch10 -p1
%patch13 -p1
%patch14 -p1
%patch16 -p1
%patch19 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1

%if %{without hpc}
# baselibs looks different for different flavors - generate it on the fly
cat >  %{_sourcedir}/baselibs.conf <<EOF
libhdf5-%{sonum}%{?my_suffix}
libhdf5_hl%{sonum_HL}%{?my_suffix}
libhdf5_fortran%{sonum_F}%{?my_suffix}
libhdf5hl_fortran%{sonum_HL_F}%{?my_suffix}
libhdf5_cpp%{sonum_CXX}%{?my_suffix}
libhdf5_hl_cpp%{sonum_HL_CXX}%{?my_suffix}
hdf5%{?my_suffix}-devel
   requires %{?my_suffix}-<targettype>
   requires "libhdf5-%{sonum}%{?my_suffix}-<targettype> = <version>"
   requires "libhdf5_hl%{sonum_HL}%{?my_suffix}-<targettype> = <version>"
   requires "libhdf5_fortran%{sonum_F}%{?my_suffix}-<targettype> = <version>"
   requires "libhdf5hl_fortran%{sonum_HL_F}%{?my_suffix}-<targettype> = <version>"
   requires "libhdf5_cpp%{sonum_CXX}%{?my_suffix}-<targettype> = <version>"
   requires "libhdf5_hl_cpp%{sonum_HL_CXX}%{?my_suffix}-<targettype> = <version>"
EOF
%endif

%build

%{?with_hpc:%hpc_setup}
%{?with_hpc:%hpc_debug}

export CC=gcc
export CXX=g++
export F9X=gfortran
export CFLAGS="%{optflags}"
%ifarch %arm
# we want to have useful H5_CFLAGS on arm too
test -e config/linux-gnueabi || cp config/linux-gnu config/linux-gnueabi
%endif

# NOTE: --enable-unsupported is required when --enable-fortran
# and/or --enable-cxx is enabled along with --enable-threadsafe.
# Building with thise combination results in thread-safe C
# libraries and non-thread-safe fotran and/or C++ libraries. So
# you have to explicitly allow building the thread-safe C
# library and the non-thread-safe C++ and fortran libraries in
# order to make sure people don't assume that their fotran or
# C++ code is thread-safe.  Since our users are going to be
# accessing this through other programs, this doesn't matter.

%if %{without hpc}
 %if  %{with mpi}
export CC="%{my_bindir}/mpicc"
export CXX="%{my_bindir}/mpicxx"
export FC="%{my_bindir}/mpif90"
export F77="%{my_bindir}/mpif77"
export LD_LIBRARY_PATH="%{my_libdir}"
 %endif
%configure \
 %if %{with mpi}
  --prefix=%{my_prefix} \
  --exec-prefix=%{_prefix} \
  --bindir=%{my_bindir} \
  --libdir=%{my_libdir} \
  --includedir=%{my_incdir} \
  --datadir=%{_datadir} \
 %endif
  --docdir=%{_docdir}/%{name} \
%else # hpc
%global _hpc_exec_prefix %hpc_exec_prefix
%global hpc_exec_prefix %_prefix
 %if %{with mpi}
export CC=mpicc
export CXX=mpicxx
export F77=mpif77
export FC=mpif90
export MPICC=mpicc
export MPIFC=mpifc
export MPICXX=mpicxx
 %endif
%hpc_configure \
%define hpc_exec_prefix %{expand:%_hpc_exec_prefix}
%endif # ?hpc
  --disable-hltools \
  --disable-dependency-tracking \
  --enable-fortran \
  --enable-unsupported \
  --enable-hl \
  --enable-shared \
  --enable-threadsafe \
  --enable-build-mode=production \
%if %{with mpi}
  --enable-parallel \
%endif
  --enable-cxx \
%if 0%{?use_sz2}
  --with-szlib \
%endif
  --with-pthread

# Remove timestamp/buildhost/kernel version
export SDE_DATE=$(date -d @${SOURCE_DATE_EPOCH} -u)
export UNAME_M_O=$(uname -m -o)
sed -i -e "s/\(Configured on: \).*/\1 $SDE_DATE/" \
       -e "s#\(Uname information: \).*#\1 $UNAME_M_O#" \
       -e "s/\(Configured by: \).*/\1 abuild@OBS/" \
       src/libhdf5.settings

make V=1 %{?_smp_mflags}

%install
%{?with_hpc:%hpc_setup}
%{?with_hpc:%hpc_debug}

make install DESTDIR=%{buildroot}
find %{buildroot} -type f -name "*.la" -delete -print

%if %{without mpi}

%if %{with hpc}
# copy to versioned subdir
install -m 755 -d %{buildroot}%{_prefix}/share/%{version}
install -m 755 -d %{buildroot}%{_prefix}/share/hdf5_examples
mv %{buildroot}%{_prefix}/lib/hpc/*/hdf5/*/share/hdf5_examples/* \
    %{buildroot}%{_prefix}/share/%{version}/
mv %{buildroot}%{_prefix}/share/%{version} \
    %{buildroot}%{_prefix}/share/hdf5_examples
%else
# rpm macro for version checking
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d/
cat > %{buildroot}%{_rpmconfigdir}/macros.d/macros.hdf5 <<EOF
#
# RPM macros for hdf5 packaging
#
%_hdf5_sonum  %{sonum}
%_hdf5_version  %{version}
EOF
%endif

%else
# delete examples from parallel builds
find  %{buildroot} -type d -name "hdf5_examples" -exec rm -rf {} +;
%endif

%fdupes -s %{buildroot}/%{_datadir}

%if %{with hpc}
%{hpc_write_pkgconfig -n hdf5 -l hdf5}
%{hpc_write_pkgconfig -n hdf5_hl -l hdf5_hl}
%{hpc_write_pkgconfig -n hdf5_fortran -l hdf5_fortran}
%{hpc_write_pkgconfig -n hdf5_hl_fortran -l hdf5hl_fortran}
%{hpc_write_pkgconfig -n hdf5_cpp -l hdf5_cpp}
%{hpc_write_pkgconfig -n hdf5_hl_cpp -l hdf5_hl_cpp}

%hpc_write_modules_files
#%%Module1.0#####################################################################

proc ModulesHelp { } {

puts stderr " "
puts stderr "This module loads the %{pname} library built with the %{compiler_family} compiler toolchain."
puts stderr "\nVersion %{version}\n"

}
module-whatis "Name: %{pname} built with %{compiler_family} toolchain"
module-whatis "Version: %{version}"
module-whatis "Category: runtime library"
module-whatis "Description: %{SUMMARY:0}"
module-whatis "%{url}"

set     version                     %{version}

prepend-path    PATH                %{hpc_bindir}
prepend-path    LD_LIBRARY_PATH     %{hpc_libdir}

setenv          %{hpc_upcase %pname}_DIR        %{hpc_prefix}
setenv          %{hpc_upcase %pname}_BIN        %{hpc_bindir}
setenv          %{hpc_upcase %pname}_LIB        %{hpc_libdir}

if {[file isdirectory  %{hpc_includedir}]} {
prepend-path    LIBRARY_PATH        %{hpc_libdir}
prepend-path    CPATH               %{hpc_includedir}
prepend-path    C_INCLUDE_PATH      %{hpc_includedir}
prepend-path    CPLUS_INCLUDE_PATH  %{hpc_includedir}
prepend-path    INCLUDE             %{hpc_includedir}
%hpc_modulefile_add_pkgconfig_path

setenv          %{hpc_upcase %pname}_INC        %{hpc_includedir}
}

family "%pname"

EOF
%endif

%if %{with check}
%check
 %if 0%{?qemu_user_space_build}
# default timeout is 1200 seconds
export HDF5_ALARM_SECONDS=3600
 %endif
 %if %{with mpi}
export HDF5_Make_Ignore=yes
 %endif
%{?with_hpc:%hpc_setup}
 %ifarch ppc ppc64 ppc64le aarch64
  make %{?_smp_mflags} check || { echo "Ignore transient make check failures for PowerPC or aarch64. boo#1058563"; }
 %else
  %if "%{?mpi_flavor}" != "mpich" || ("%_arch" != "s390" && "%_arch" != "s390x")
    make %{?_smp_mflags} check
  %endif
 %endif
%endif

%post -n %{libname -l _cpp -s %{sonum_CXX}} -p /sbin/ldconfig
%postun -n %{libname -l _cpp -s %{sonum_CXX}} -p /sbin/ldconfig
%post -n %{libname -l _hl_cpp -s %{sonum_HL_CXX}} -p /sbin/ldconfig
%postun -n %{libname -l _hl_cpp -s %{sonum_HL_CXX}} -p /sbin/ldconfig
%post -n %{libname -s %{sonum}} -p /sbin/ldconfig
%postun -n %{libname -s %{sonum}} -p /sbin/ldconfig
%post -n %{libname -l _hl -s %{sonum_HL}} -p /sbin/ldconfig
%postun -n %{libname -l _hl -s %{sonum_HL}} -p /sbin/ldconfig
%post -n %{libname -l _fortran -s %{sonum_F}} -p /sbin/ldconfig
%postun -n %{libname -l _fortran -s %{sonum_F}} -p /sbin/ldconfig
%post -n %{libname -l hl_fortran -s %{sonum_HL_F}} -p /sbin/ldconfig
%postun -n %{libname -l hl_fortran -s %{sonum_HL_F}} -p /sbin/ldconfig

%if %{with hpc}
%postun module
%hpc_module_delete_if_default
%endif

%if 0%{?sle_version} > 120200 || 0%{?suse_version} > 1320
%define mylicense %license
%else
%define mylicense %doc
%endif

%if %{without mpi}
%files -n %{vname}-examples
%{?with_hpc:%dir %{_prefix}/share/hdf5_examples}
%{_prefix}/share/hdf5_examples%{?with_hpc:/%{version}}

%if %{without hpc}
%files -n %{pname}-devel-data
%{_rpmconfigdir}/macros.d/macros.hdf5
%endif
%endif # ?mpi

%files -n %{name}
%{?with_hpc:%dir %my_bindir}
%{my_bindir}/h5clear
%{my_bindir}/h5copy
%{my_bindir}/h5debug
%{my_bindir}/h5diff
%{my_bindir}/h5dump
%{my_bindir}/h5format_convert
%{my_bindir}/h5import
%{my_bindir}/h5jam
%{my_bindir}/h5ls
%{my_bindir}/h5mkgrp
%if %{with mpi}
%{my_bindir}/ph5diff
%{my_bindir}/h5perf
%endif
%{my_bindir}/h5perf_serial
%{my_bindir}/h5redeploy
%{my_bindir}/h5repack
%{my_bindir}/h5repart
%{my_bindir}/h5stat
%{my_bindir}/h5unjam
%{my_bindir}/h5watch

%files -n %{libname -s %{sonum}}
%doc ACKNOWLEDGMENTS
%mylicense COPYING
##
%if %{without mpi}
%doc release_docs/HISTORY-1_8_0-1_10_0.txt
%doc release_docs/RELEASE.txt
%endif
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5.so.%{sonum}
%{my_libdir}/libhdf5.so.%{sonum}.*

%files -n %{libname -l _hl -s %{sonum_HL}}
%mylicense COPYING
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5_hl.so.%{sonum_HL}
%{my_libdir}/libhdf5_hl.so.%{sonum_HL}.*

%files -n %{libname -l _cpp -s %{sonum_CXX}}
%mylicense COPYING
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5_cpp.so.%{sonum_CXX}
%{my_libdir}/libhdf5_cpp.so.%{sonum_CXX}.*

%files -n %{libname -l _hl_cpp -s %{sonum_HL_CXX}}
%mylicense COPYING
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5_hl_cpp.so.%{sonum_HL_CXX}
%{my_libdir}/libhdf5_hl_cpp.so.%{sonum_HL_CXX}.*

%files -n %{libname -l _fortran -s %{sonum_F}}
%mylicense COPYING
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5_fortran.so.%{sonum_F}
%{my_libdir}/libhdf5_fortran.so.%{sonum_F}.*

%files -n %{libname -l hl_fortran -s %{sonum_HL_F}}
%mylicense COPYING
%defattr(0755,root,root)
%{?with_hpc:%hpc_dirs}
%{my_libdir}/libhdf5hl_fortran.so.%{sonum_HL_F}
%{my_libdir}/libhdf5hl_fortran.so.%{sonum_HL_F}.*

%if %{with hpc}
%files module
%hpc_modules_files
%endif

%files devel
##
%{?with_hpc:%dir %{my_incdir}}
%doc release_docs/RELEASE.txt
%doc ACKNOWLEDGMENTS
%{?with_hpc:%{hpc_pkgconfig_file -n hdf5}}
%{?with_hpc:%{hpc_pkgconfig_file -N -n hdf5_hl}}
%{?with_hpc:%{hpc_pkgconfig_file -N -n hdf5_fortran}}
%{?with_hpc:%{hpc_pkgconfig_file -N -n hdf5_hl_fortran}}
%{?with_hpc:%{hpc_pkgconfig_file -N -n hdf5_cpp}}
%{?with_hpc:%{hpc_pkgconfig_file -N -n hdf5_hl_cpp}}
%{my_bindir}/h5c++
%if %{without mpi}
%{my_bindir}/h5cc
%{my_bindir}/h5fc
%else
%{my_bindir}/h5pcc
%{my_bindir}/h5pfc
%endif
%{my_incdir}/*.h
%{my_libdir}/*.so
%{my_libdir}/*.settings
%{my_incdir}/*.mod

%files devel-static
%{my_libdir}/*.a

%changelog
* Thu Jun  6 2024 eich@suse.com
- Fix bsc#1224158 - this fixes:
  CVE-2024-29158, CVE-2024-29161, CVE-2024-29166, CVE-2024-32608,
  CVE-2024-32610, CVE-2024-32614, CVE-2024-32619, CVE-2024-32620,
  CVE-2024-33873, CVE-2024-33874, CVE-2024-33875
  Additionally, these fixes resolve crashes triggered by the
  reproducers for CVE-2017-17507, CVE-2018-11205. These crashes
  appear to be unrelated to the original problems.
  Patches added:
  H5O-patches-partial.patch
  Add-H5F-RFIC-boilerplate.patch
  Add-H5T_is_numeric_with_unusual_unused_bits.patch
  Add-H5_RANGE_OVERLAP.patch
  Patch-H5Odtype.c.patch
  Patch-H5Tcommit.c.patch
  Add-unused-bits-checks-and-tools-patches.patch
  Update-overflow-macro.patch
  Update-H5_IS_BUFFER_OVERFLOW-to-account-for-size-of-0.patch
  Fixes-for-file-format-security-issues.patch
  Make-sure-unused-attribute-entries-are-NULLed.patch
  Add-sanity-and-overrun-checks-to-H5HG__cache_heap_deserialize.patch
  Mark-datatype-as-freed-always.patch
  Fix-an-uninitialized-value-warning.patch
* Thu Jan 25 2024 eich@suse.com
- Updated to version 1.10.11
  * Changed the error handling for a not found path in the find
    plugin process.
  * Fixed CVE-2018-11202, a malformed file could result in chunk
    index memory leaks.
  * Fixed a file space allocation bug in the parallel library for
    chunked datasets.
  * Fixed an assertion failure in Parallel HDF5 when a file can't
    be created due to an invalid library version bounds setting.
  * Fixed an assertion in a previous fix for CVE-2016-4332.
  * Fixed segfault on file close in h5debug which fails with a core
    dump on a file that has an illegal file size in its cache image.
    Fixes HDFFV-11052, CVE-2020-10812.
  * Fixed memory leaks that could occur when reading a dataset from
    a malformed file.
  * Fixed a bug in H5Ocopy that could generate invalid HDF5 files
  * Fixed potential heap buffer overflow in decoding of link info
    message.
  * Fixed potential buffer overrun issues in some object header
    decode routines.
  * Fixed a heap buffer overflow that occurs when reading from
    a dataset with a compact layout within a malformed HDF5 file.
  * Fixed CVE-2019-8396, malformed HDF5 files where content does
    not match expected size.
  * Fixed memory leak when running h5dump with proof of
    vulnerability file.
  * Added option --no-compact-subset to h5diff.
  Fixes since 1.10.10:
  * Fixed a memory corruption when reading from dataset using a
    hyperslab selection in file dataspace and a point selection
    memory dataspace.
  * Fix CVE-2021-37501
  * Fixed an issue with variable length attributes.
  * Fixed an issue with hyperslab selections where an incorrect
    combined selection was produced.
  * Fixed an issue with attribute type conversion with compound
    datatypes.
  * Modified H5Fstart_swmr_write() to preserve DAPL properties.
  * Converted an assertion on (possibly corrupt) file contents to
    a normal error check.
  * Fixed memory leak with variable-length fill value in
    H5O_fill_convert().
  * Fix h5repack to only print output when verbose option is
    selected.
  Fixes since 1.10.9:
  * Several improvements to parallel compression feature,
    including:
    + Improved support for collective I/O (for both writes and
    reads).
    + Reduction of copying of application data buffers passed to
    H5Dwrite.
    + Addition of support for incremental file space allocation
    for filtered datasets created in parallel.
    + Addition of support for HDF5's "don't filter partial edge
    chunks" flag
    + Addition of proper support for HDF5 fill values with the
    feature.
    + Addition of 'H5_HAVE_PARALLEL_FILTERED_WRITES' macro to
    H5pubconf.h
    so HDF5 applications can determine at compile-time whether
    the feature is available.
    + Addition of simple examples
  * h5repack added an optional verbose value for reporting R/W
    timing.
  * Fixed a metadata cache bug when resizing a pinned/protected
    cache entry.
  * Fixed a problem with the H5_VERS_RELEASE check in the
    H5check_version function.
  * Unified handling of collective metadata reads to correctly fix
    old bugs.
  * Fixed several potential MPI deadlocks in library failure
    conditions.
  * Fixed an issue with collective metadata reads being permanently
    disabled after a dataset chunk lookup operation.
- Remove obsolete patch:
  * hdf5-mpi.patch
- Remove upstreamed fixes:
  * hdf5-1.10.8-pr1494-fix-release-check-version.patch
  * Compound-datatypes-may-not-have-members-of-size-0.patch
  * Validate-location-offset-of-the-accumulated-metadata-when-comparing.patch
  * Hot-fix-for-CVE-2020-10812.patch
  * H5O__pline_decode-Make-more-resilient-to-out-of-bounds-read.patch
  * Pass-compact-chunk-size-info-to-ensure-requested-elements-are-within-bounds.patch
  * Report-error-if-dimensions-of-chunked-storage-in-data-layout-2.patch
  * H5O_dtype_decode_helper-Parent-of-enum-needs-to-have-same-size-as-enum-itself.patch
  * Check-for-overflow-when-calculating-on-disk-attribute-data-size-2459.patch
  * Remove-duplicate-code.patch
* Sun Mar 19 2023 stefan.bruens@rwth-aachen.de
- Remove timestamp/buildhost/kernel version from libhdf5.settings (boo#1209548).
* Mon Feb 13 2023 eich@suse.com
- Fix CVE-2021-37501 - overflow in calculation of data buffer due to bogus
  input file (bsc#1207973).
  https://github.com/HDFGroup/hdf5/issues/2458
  https://github.com/HDFGroup/hdf5/pull/2459
  Check-for-overflow-when-calculating-on-disk-attribute-data-size-2459.patch
  Remove-duplicate-code.patch
* Thu Oct 13 2022 eich@suse.com
- Fix CVEs:
  * CVE-2021-46244 (bsc#1195215)
    Compound-datatypes-may-not-have-members-of-size-0.patch
  * CVE-2018-13867 (bsc#1101906)
    Validate-location-offset-of-the-accumulated-metadata-when-comparing.patch
  * CVE-2018-16438 (bsc#1107069)
    Make-sure-info-block-for-external-links-has-at-least-3-bytes.patch
  * CVE-2020-10812 (bsc#1167400)
    Hot-fix-for-CVE-2020-10812.patch
  * CVE-2021-45830 (bsc#1194375)
    H5O_fsinfo_decode-Make-more-resilient-to-out-of-bounds-read.patch
  * CVE-2019-8396 (bsc#1125882)
    H5O__pline_decode-Make-more-resilient-to-out-of-bounds-read.patch
  * CVE-2018-11205 (bsc#1093663)
    Pass-compact-chunk-size-info-to-ensure-requested-elements-are-within-bounds.patch
  * CVE-2021-46242 (bsc#1195212)
    When-evicting-driver-info-block-NULL-the-corresponding-entry.patch
  * CVE-2021-45833 (bsc#1194366)
    Report-error-if-dimensions-of-chunked-storage-in-data-layout-2.patch
  * CVE-2018-14031 (bsc#1101475)
    H5O_dtype_decode_helper-Parent-of-enum-needs-to-have-same-size-as-enum-itself.patch
  * CVE-2018-17439 (bsc#1111598)
    H5IMget_image_info-H5Sget_simple_extent_dims-does-not-exceed-array-size.patch
- Fix an error message:
    Fix-error-message-not-the-name-but-the-link-information-is-parsed.patch
* Wed May  4 2022 eich@suse.com
- Security Fix:
  Add configure option --disable-hltools to disable GIF tools as
  recommended in the 1.10.8 release:
  CVE-2018-17433 (bsc#1109565),
  CVE-2018-17436 (bsc#1109568),
  CVE-2020-10809 (bsc#1167404).
* Thu Apr  7 2022 junghans@votca.org
- add hdf5-wrappers.patch from Fedora, so strip flags from
  wrappers and prefer shared linking
- add missing zlib-devel devel dep
* Thu Mar 31 2022 code@bnavigator.de
- Add hdf5-1.10.8-pr1494-fix-release-check-version.patch
  * boo#1179521, boo#1196682, gh#HDFGroup/hdf5#1494
  * Avoids package crashes due to an overeager version check.
    Packages depending on the shared libraries are not being
    rebuilt in Factory after a patchlevel version bump of hdf5
    without SONAME changes.
* Wed Feb 16 2022 badshah400@gmail.com
- Update to version 1.10.8:
  * Added new option to control the build of High-Level tools
  * Adds C++ Autotools configuration file for Intel
  * Adds C++ Autotools configuration file for PGI
  * Updates PGI C options
  * CMake will now run the shell script tests in test/ by default
  * Removed unused HDF5_ENABLE_HSIZET option from CMake
  * CMake no longer builds the C++ library by default
  * Removal of pre-VS2015 work-arounds
  * Add CMake variable HDF5_LIB_INFIX
  * Added a configure-time option to control certain compiler
    warnings
  * CMake option to build the HDF filter plugins project as an
    external project
  * Added a configure-time option to consider certain compiler
    warnings
  * Autotools and CMake target added to produce doxygen generated
    documentation
  * CMake option to build the HDF filter plugins project as an
    external project
  * Added CMake option to format source files
  * Change how the release part of version, in major.minor.release
    is checked
  * H5Gcreate1() now rejects size_hint parameters larger than
    UINT32_MAX
  * H5Pset_fapl_log() no longer crashes when passed an invalid
    fapl ID
  * Fixes a segfault when H5Pset_mdc_log_options() is called
    multiple times
  * File locking now works on Windows
  * H5Epush_ret() now requires a trailing semicolon
  * Improved performance of H5Sget_select_elem_pointlist
  * H5Fget_name_f fixed to handle correctly trailing whitespaces
    and newly allocated buffers.
  * Added new H5S functions.
  * Refactored the perform tools and removed dependencies on test
    library.
  * h5repack added help text for user-defined filters.
  * Doxygen documentation is available when configured and
    generated.
  * Fixed CVE-2018-17432 (bsc#1109564)
  * Fixed a segmentation fault
  * Detection of simple data transform function "x"
  * Fixed CVE-2020-10810 - an invalid read and memory leak when
    parsing (bsc#1167401)
  * Fixed CVE-2018-14460 (bsc#1102175)
  * Fixed CVE-2018-11206 (bsc#1093657)
    (same issue as CVE-2018-14032 (bsc#1101474))
  * Fixed CVE-2018-14033 (bsc#1101471)
    (same issue as CVE-2020-10811 (bsc#1167405))
  * Remove underscores on header file guards
  * H5FArray.java class:
  - Convert the entire byte array into a 1-d array of the
    desired type, rather than performing 1 conversion per row;
  - Use the Java Arrays method copyOfRange to grab the section
    of the array from (1) that is desired to be inserted into
    the destination array.
  * Corrected path searched by CMake find_package command
  * Corrected pkg-config compile script
  * Fixed CMake C++ compiler flags
  * Autotools clang debug optimization level change
  * Better support for libaec (open-source Szip library) in CMake
  * Refactor CMake configure for Fortran
  * Remove arbitrary warning flag groups from CMake builds
  * Reclassify CMake messages, to allow new modes and --log-level
    option
  * Fixes Autotools determination of the stat struct having an
    st_blocks field
  * Changed how h5dump and h5ls identify long double.
  * Fixed tools argument parsing.
  * Updated doxygen comments with changes for release
- Minor rebase of patches to apply cleanly.
* Fri Jan 29 2021 eich@suse.com
- Fix update_so_version.sh, write so versions to file being included.
* Fri Nov  6 2020 aguerrero@suse.com
- Update to version 1.10.7
  * Add metadata cache optimization to reduce skip list usage.
  * Add BEST_EFFORT value to HDF5_USE_FILE_LOCKING environment variable.
  * Add H5Pset/get_file_locking() API calls.
  * Add Mirror VFD.
    Use TCP/IP sockets to perform write-only (W/O) file I/O on a remote
    machine. Must be used in conjunction with the Splitter VFD.
  * Add Splitter VFD.
    Maintain separate R/W and W/O channels for "concurrent" file writes
    to two files using a single HDF5 file handle.
  * Fixed an assertion failure in the parallel library when collectively
  filling chunks.
  * Fortran/C++ libs: Add wrappers for H5Pset/get_file_locking() API calls.
    h5pget_file_locking_f()
    h5pset_file_locking_f()
  * Added new Fortran parameters:
    H5F_LIBVER_ERROR_F
    H5F_LIBVER_NBOUNDS_F
    H5F_LIBVER_V18_F
    H5F_LIBVER_V110_F
  * Add new Fortran API: h5pget_libver_bounds_f.
  * h5repack added options to control how external links are handled.
  * The tools library was updated by standardizing the error stack process.
  * The H5DSis_scale function was updated to return "not a dimension scale" (0)
    instead of failing (-1), when CLASS or DIMENSION_SCALE attributes are
    not written according to Dimension Scales Specification.
  * Bug Fixes:
    + Fix bug and simplify collective metadata write operation when some ranks
    have no entries to contribute.  This fixes parallel regression test
    failures with IBM SpectrumScale MPI on the Summit system at ORNL.
    + Fixed use-of-uninitialized-value error.
    Appropriate initialization of local structs was added to remove the
    use-of-uninitialized-value errors reported by MemorySanitizer.
    + Creation of dataset with optional filter.
    A fix is applied to allow the creation of a dataset in such
    situation, as specified in the user documentation.
    + Explicitly declared dlopen to use RTLD_LOCAL.
    + H5Sset_extent_none() sets the dataspace class to H5S_NO_CLASS which
    causes asserts/errors when passed to other dataspace API calls.
    + Fixed the segmentation fault when reading attributes with multiple threads
    The problem was fixed by setting the file pointer to the current opened
    file pointer when the attribute was accessed.  Similar patch up was done
    before when reading dataset with variable length string datatype.
    + Don't allocate an empty (0-dimensioned) chunked dataset's chunk
    index, until the dataset's dimensions are increased.
    + Fortan: Corrected INTERFACE INTENT(IN) to INTENT(OUT) for buf_size in
    h5fget_file_image_f.
    + h5diff fixed a command line parsing error.
    + h5diff added a command line option to ignore attributes.
    + h5diff added another level to the verbose argument to print filenames.
    + h5repack was fixed to repack the reference attributes properly.
  * For details check:
    https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.7/src/hdf5-1.10.7-RELEASE.txt
- version 1.10.6
  * Added S3 and HDFS Virtual File Drivers (VFDs) to HDF5.
    Instructions to enable them when configuring HDF5 on Linux and Mac
    may be found at.
    https://portal.hdfgroup.org/display/HDF5/Virtual+File+Drivers+-+S3+and+HDFS.
  * Added new wrappers for H5Pset/get_create_intermediate_group()
    LinkCreatPropList::setCreateIntermediateGroup()
    LinkCreatPropList::getCreateIntermediateGroup()
  * h5repack was fixed to repack datasets with external storage
    to other types of storage.
  * Bug Fixes:
    + Improved performance when creating a large number of small datasets by
    retrieving default property values from the API context instead of doing
    skip list searches. More work is required to achieve parity with HDF5 1.8.
    + Fixed user-created data access properties not existing in the property list
    returned by H5Dget_access_plist. Thanks to Steven Varga for submitting a
    reproducer and a patch.
    + Inappropriate linking with deprecated MPI C++ libraries.
    HDF5 does not define *_SKIP_MPICXX in the public headers, so applications
    can inadvertently wind up linking to the deprecated MPI C++ wrappers.
    MPICH_SKIP_MPICXX and OMPI_SKIP_MPICXX have both been defined in H5public.h
    so this should no longer be an issue. HDF5 makes no use of the deprecated
    MPI C++ wrappers.
    + fcntl(2)-based file locking incorrectly passed the lock argument struct
    instead of a pointer to the struct, causing errors on systems where
    flock(2) is not available.
    This bug affects HDF5 1.10.0 through 1.10.5.
    fcntl(2)-based file locking now correctly passes the struct pointer.
    + Fixed a bug caused by a bad tag value when condensing object header
    messages.
    + Fixed an issue when creating a file with non-default file space info
    together with library high bound setting to H5F_LIBVER_V18.
    This was fixed by setting and checking the proper version in the file
    space info message based on the library low and high bounds when creating
    and opening the HDF5 file.
    + Fixed an issue where copying a version 1.8 dataset between files using
    H5Ocopy fails due to an incompatible fill version.
    + Fixed a bug that would cause an error or cause fill values to be
    incorrectly read from a chunked dataset using the "single chunk" index if
    + Fixed a bug that could cause an error or cause fill values to be
    incorrectly read from a dataset that was written to using H5Dwrite_chunk
    if the dataset was not closed after writing.
    + Fixed memory leak in scale offset filter.
  * For details check:
    https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.6/src/hdf5-1.10.6-RELEASE.txt
- Security bugs fixed:
  * CVE-2018-13870: heap-based buffer over-read in the function
    H5O_link_decode in H5Olink.c  (bsc#1101493)
  * CVE-2018-13869: memcpy parameter overlap in the function
    H5O_link_decode in H5Olink.c (bsc#1101495)
  * CVE-2018-17438:  A SIGFPE signal is raised in the function
    H5D__select_io() of H5Dselect.c in the HDF HDF5 through 1.10.3
    (bsc#1109570)
    library during an attempted parse of a crafted HDF file,
    because of incorrect protection against division
    (bsc#1109570)
  * CVE-2018-17435: A heap-based buffer over-read in H5O_attr_decode()
    in H5Oattr.c in the HDF HDF5 through 1.10.3 library allows
    attackers to cause a denial of service via a crafted HDF5 file.
    (bsc#1109567)
- Refresh patches
* Thu Jul 23 2020 eich@suse.com
- Add build support for gcc10 to HPC build (bsc#1174439).
* Mon Jul 20 2020 eich@suse.com
- Add missing openmpi4 flavors.
- Enable build of non-HPC flavors for all non-HPC builds.
* Wed Jun 24 2020 alinm.elena@gmail.com
- add openmpi4 packages to build and disable build for leap
* Fri Apr 17 2020 eich@suse.com
- Fix .so number in baselibs.conf for libhdf5_fortran libs (boo#1169793).
* Thu Apr  2 2020 eich@suse.com
- Fix library link flags on pkg-config file for HPC builds (boo#1134298).
* Mon Jan 20 2020 stefan.bruens@rwth-aachen.de
- Remove bogus undefines of suffix and mpi_flavor. suffix is the
  name of an RPM built-in (like expand or echo), and since RPM 4.15
  trying to alter a built-in is an error. Fixes built of serial
  flavor on Tumbleweed. See https://rpm.org/user_doc/macros.html
* Tue Dec 10 2019 stefan.bruens@rwth-aachen.de
- Add compat provides for renamed hdf5-openmpi{,-devel} package,
  see https://en.opensuse.org/openSUSE:Package_dependencies
- Fix openmpi1 package naming for SLE/Leap <= 15.1
* Thu Nov 28 2019 eich@suse.com
- Add HPC support for gcc8 and gcc9 (jsc#SLE-7766 & jsc#SLE-8604).
* Thu Nov 28 2019 eich@suse.com
- Disable openmpi1 builds for SLE/Leap > 15.1.
- Enable openmpi3 builds for Leap and SLE > 15.1 (jsc#SLE-7773).
* Thu Oct 24 2019 nmoreychaisemartin@suse.com
- openmpi has been renamed into openmpi1
* Tue Sep 10 2019 aguerrero@suse.com
- Use -ffat-lto-objects to provide a proper static library.
* Tue Sep  3 2019 aguerrero@suse.com
- Re-list hdf5-mpi.patch in the spec file for the sake of a avoiding
  a script rejecting the package automatically.
* Fri Aug 23 2019 aguerrero@suse.com
- Update to version 1.10.5: (jsc#SLE-8501)
  * https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.5/src/hdf5-1.10.5-RELEASE.txt
- Security bugs fixed:
  * CVE-2018-17233: A SIGFPE signal is raised in the function
  H5D__create_chunk_file_map_hyper. (bsc#1109166)
  * CVE-2018-17234: Memory leak in the H5O__chunk_deserialize()
  function in H5Ocache.c (bsc#1109167)
  * CVE-2018-17434: A SIGFPE signal is raised in function apply_filters()
  of h5repack_filters.c (bsc#1109566)
  * CVE-2018-17437: Memory leak in the H5O_dtype_decode_helper() function
  in H5Odtype.c. (bsc#1109569)
  * CVE-2018-17237: A SIGFPE signal is raised in the function
  H5D__chunk_set_info_real (bsc#1109168) (commit 4e31361d).
- Bump fortran library soname, sonum_F from 100 to 102.
- Adjust library installation path, use %%hpc_prefix/lib64 in x86_64
  and %%hpc_libdir in all other cases
- Patches refreshed:
  * hdf5-LD_LIBRARY_PATH.patch
  * hdf5-1.8.11-abort_unknown_host_config.patch
  * PPC64LE-Fix-long-double-handling.patch
  * hdf5-Remove-timestamps-from-binaries.patch
  * Disable-phdf5-tests.patch
- Patch disabled, upstream have changed the file that was being patched,
  while it could be ported, it's unknown if this patch is still needed.
  * hdf5-mpi.patch
- Patch removed, merged upstream
  * 0001-Fix-return-value-in-test_libver_bounds_open.patch
* Thu Jul  4 2019 eich@suse.com
- Since build machine size issues do not seem to go way, make
  the %%check stage optional: enable with '--with check'.
* Thu Apr 25 2019 cgoll@suse.com
- set higher constraints for succesful mpich tests (boo#1332222)
* Mon Apr  1 2019 normand@linux.vnet.ibm.com
- Add _constraints to avoid transient build error ppc64le
* Sat Mar  9 2019 stefan.bruens@rwth-aachen.de
- Update URL: and Source: to use https://.
* Fri Mar  1 2019 eich@suse.com
- Like on PPC ignore transient 'make check' failures on aarch64.
* Fri Mar  1 2019 eich@suse.com
- Remove ringdisabled magic as hdf5 is no longer a ring package.
  This should resolve a number of problems in the review channels
  for Factory with packages requiring hdf5 libs.
* Wed Feb 13 2019 eich@suse.com
- Consolidate use of openmpi1, openmpi2, openmpi3 for non-HPC builds.
* Fri Jan 25 2019 eich@suse.com
- Remove dependency to the hdf5-devel-data file for HPC:
  Currently, there are no macro files for HPC - these files
  will have to be handled differently.
- Re-disable all non-HPC builds for SLE.
* Mon Jan 14 2019 eich@suse.com
- Reenable 'serial' build for SLE: this build creates hdf5-devel-data.
* Thu Jan  3 2019 eich@suse.com
- Do not build non-HPC on SLE: This helps to save some build
  cycles.
* Wed Dec 19 2018 toddrme2178@gmail.com
- Use upstream-recommended %%{_rpmconfigdir}/macros.d directory
  for the rpm macros.
* Wed Dec 12 2018 toddrme2178@gmail.com
- Also build for regular openmpi2 and openmpi3
* Thu Nov 22 2018 stefan.bruens@rwth-aachen.de
- Build HDF5 C++ bindings also for the MPI variants, there is no reason
  not to do it.
- Enable sz2 support also for MPI variants.
* Mon Nov 19 2018 eich@suse.com
- Replace git-archive generated by downloaded tar-ball.
* Sat Nov 17 2018 eich@suse.com
- Update to 1.10.4:
  https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.4/src/hdf5-1.10.4-RELEASE.txt
  * Update Disable-phdf5-tests.patch
  * Replace and update hdf5-buildcompare.patch by
    hdf5-Remove-timestamps-from-binaries.patch
* Fri Nov 16 2018 eich@suse.com
- Remove lib*_cpp and lib*_hl_cpp dependencies for MPI for the time
  being.
* Sun Nov 11 2018 eich@suse.com
- Create main master package, fix dependencies.
* Fri Sep 21 2018 stefan.bruens@rwth-aachen.de
- Update to 1.10.3:
  https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.3/src/hdf5-1.10.3-RELEASE.txt
- Update to 1.10.2:
  https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.2/src/hdf5-1.10.2-RELEASE.txt
- Bump soversions (101 -> 103) for libhdf5 and libhdf5_cpp
- Drop Fix-warnings-for-missing-returns.patch, fixed upstream
- Add 0001-Fix-return-value-in-test_libver_bounds_open.patch
- Rebase patches (tab / space conversion):
  * PPC64LE-Fix-long-double-handling.patch
  * hdf5-buildcompare.patch
  * hdf5-mpi.patch
- Rebase Disable-phdf5-tests.patch
- Security bugs fixed:
  * CVE-2017-17505: NULL pointer dereference in the function
    H5O_pline_decode allowing for DoS via crafted file (bsc#1072087)
  * CVE-2017-17506: Out of bounds read in the function
    H5Opline_pline_decode (bsc#1072090)
  * CVE-2017-17508: divide-by-zero vulnerability in function
    H5T_set_loc (bsc#1072108)
  * CVE-2017-17509: out of bounds write vulnerability in function
    H5G__ent_decode_vec (bsc#1072111)
  * CVE-2018-11202: NULL pointer dereference in H5S_hyper_make_spans
    in H5Shyper.c allows a remote denial of service attack (bsc#1093641)
  * CVE-2018-11203: division by zero in H5D__btree_decode_key in H5Dbtree.c
    It could allow a remote denial of service attack (bsc#1093649)
  * CVE-2018-11204: A NULL pointer dereference was discovered in
    H5O__chunk_deserialize in H5Ocache.c (bsc#1093655)
  * CVE-2018-11206: A out of bounds read was discovered
    in H5O_fill_new_decode and H5O_fill_old_decode in H5Ofill.c
    (bsc#1093657)
  * CVE-2018-11207: division by zero was discovered in H5D__chunk_init
    in H5Dchunk.c (bsc#1093653)
* Tue Jun 19 2018 eich@suse.com
- Handle license file using %%license where applicable.
- Package example package also for HPC build and create
  a master file for it.
* Fri Apr 27 2018 eich@suse.com
- Fix HPC library master packages dependency: make it require
  the correct flavor (bsc#1091237).
* Sat Apr  7 2018 eich@suse.com
- Only build one examples package for all flavors, do not
  include dependencies as these would be flavor specific
  (bsc#1088547).
* Sat Mar 31 2018 stefan.bruens@rwth-aachen.de
- Fix some typos, one trivial, two mispelled macros
* Sat Feb 10 2018 jengelh@inai.de
- Trim description for size and drop most of the marketing blurb.
  Fix RPM groups.
* Sat Feb 10 2018 eich@suse.com
- Make module files package arch dependent: it
  contains arch-dependent paths (boo#1080442).
* Sat Feb 10 2018 eich@suse.com
- Prepend PKG_CONFIG_PATH in modules file (boo#1080426).
* Fri Feb  9 2018 eich@suse.com
- Add support for openmpi2 for HPC (FATE#325089).
* Fri Feb  9 2018 cgoll@suse.com
- Fix summary in module files (bnc#1080259)
* Thu Feb  8 2018 eich@suse.com
- Disable %%check stage for mpich builds on s390(x) (bsc#1080022).
* Fri Jan 12 2018 eich@suse.com
- Disable the openmpi3 flavor in some products.
* Fri Jan  5 2018 eich@suse.com
- Switch from gcc6 to gcc7 as additional compiler flavor for HPC on SLES.
- Add support for mpich and openmpi3 for HPC.
* Thu Nov  9 2017 normand@linux.vnet.ibm.com
-  temporarily disable make check for PowerPC boo#1058563
* Tue Nov  7 2017 eich@suse.com
- Update to 1.10.1:
  https://support.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.1/src/hdf5-1.10.1-RELEASE.txt
- Fix-warnings-for-missing-returns.patch:
  replace: hdf5-non_void_return.patch
- PPC64LE-Fix-long-double-handling.patch:
  replace: hdf5-ldouble-ppc64le.patch
- Disable-phdf5-tests.patch:
  replace: hdf5_disable_testphdf5.patch
- Disabling validation tests for the MPI variant for now as they
  seem to cause issues in OBS.
* Thu Oct 26 2017 eich@suse.com
- Fix name: baselib.conf -> baselibs.conf
* Sun Oct 22 2017 eich@suse.com
- Remove openssl-devel and krb5-devel from the BuildRequires.
* Tue Oct 17 2017 eich@suse.com
- Add magic to limit the number of flavors built in the OBS ring
  to non-HPC and mvapich2 builds.
- Fix %%libname() for non-HPC builds.
- Fix some summaries and a Requires: of devel-static.
* Fri Sep  8 2017 eich@suse.com
- Convert package to multibuild.
- Add HPC build using environment modules
  (FATE#321717, FATE#321710).
* Tue Aug 29 2017 hpj@urpla.net
- fix compiler flag substitution
* Mon Jul  3 2017 badshah400@gmail.com
- Add libsz2-devel to list of Requires for -devel packages, this
  is required for compilation against hdf5 when szlib support is
  enabled.
- Minor specfile cleanups using spec-cleaner.
* Fri Jun 16 2017 junghans@votca.org
- Enabled szlib support through libaec's szlib API
* Wed Oct  5 2016 toddrme2178@gmail.com
- Fix baselibs.conf so numbers.
  Fixes bnc#1002569
* Tue Sep  6 2016 normand@linux.vnet.ibm.com
-  new hdf5_disable_testphdf5.patch to disable only testphdf5
  for all arches and not all mpi tests for ppc64le
  tempo patch as long as boo#997252 not solved
* Mon Sep  5 2016 normand@linux.vnet.ibm.com
-  temporarily disable mpi test for ppc64le
* Tue Jul 26 2016 adrian@suse.de
- update to 1.10.0-patch1
  https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.10/hdf5-1.10.0-patch1/src/hdf5-1.10.0-patch1-RELEASE.txt
* Mon May 23 2016 toddrme2178@gmail.com
- update to 1.8.17, changes documented here:
  https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.8.17/src/hdf5-1.8.17-RELEASE.txt
* Fri Apr 15 2016 normand@linux.vnet.ibm.com
- add hdf5-mpi.patch same as fedora commit id
  78ddcff82b10fd80eafb7b2dc5e4ce2bb9ecbe3c
  should avoid transient hung of t_pflush1 test
* Fri Mar 18 2016 toddrme2178@gmail.com
- Split libraries into C, C++, and Fortran versions to comply with
  openSUSE library packaging policies.
  Fixes BNC#971602
- Make Fortran builds required.
- Manually set so numbers.  The autodetected ones weren't matching
  the real ones.
* Mon Mar  7 2016 olaf@aepfle.de
- Remove timestamps from binaries
  hdf5-buildcompare.patch
* Thu Jan 28 2016 sweet_f_a@gmx.de
- update to 1.8.16, changes documented here:
  https://www.hdfgroup.org/ftp/HDF5/releases/hdf5-1.8.16/src/hdf5-1.8.16-RELEASE.txt
- rebase hdf5-ldouble-ppc64le.patch
- remove hdf5-cpp-compilation-errors.patch
- prepare independent so versions and add TODO
* Fri Aug 21 2015 toddrme2178@gmail.com
- Currently the regular, openmpi, and mpivachi2 versions of the
  library packages all provide the exact same libraries.  So any
  package built against the -devel package will end up with an
  "unresolvable" build error because there are multiple versions
  of the library it can use. To avoid this, I have added generic
  provides for the library package so packages can depend on the
  version they really need, avoiding these build issues.
* Thu Aug 13 2015 badshah400@gmail.com
- Add hdf5-cpp-compilation-errors.patch: Reverts a change from
  v1.8.15 to H5api_adpt.h that caused compilation errors for C++
  HDF5 applications; patch taken from upstream svn.
* Mon Jul 27 2015 toddrme2178@gmail.com
- Update subpackage groups
- Make subpackage summaries and descriptions more consistent
- Provide rpm macros for version identification
- Spec file cleanups
* Mon Jul 27 2015 toddrme2178@gmail.com
- Use explicit library requirements to avoid ambiguities.
  Without this, packages that depend on hdf5 won't know which
  library to use.
* Thu Jul 23 2015 toddrme2178@gmail.com
- Fix baselibs.conf
* Wed Jul 22 2015 toddrme2178@gmail.com
- update to 1.8.15
  * New Features
    + Library
  - Added Memory Allocation Functions that Use the Library's Allocator
  - H5Pset_istore_k and H5Pset_sym_k added validation of "ik" to not
    exceed the max v1 btree entries (2 bytes) to these two routines.
  - Added Functions to Control the Value of H5PL_no_plugin_g without
    Using an Environment Variable
    + Parallel Library
  - Attached an attribute destroy callback to MPI_COMM_SELF that
    shuts down the HDF5 library when MPI_COMM_SELF is destroyed,
    in other words, on MPI_Finalize. This should fix several issues
    that users see when they forget to close HDF5 objects before
    + Fortran API
  - Added Global Variables. These new global variables are equivalent to
    the C definitions  without the '_F':
    o H5G_UDLINK_F
    o H5G_SAME_LOC_F
    o H5O_TYPE_UNKNOWN_F
    o H5O_TYPE_GROUP_F
    o H5O_TYPE_DATASET_F
    o H5O_NAMED_DATATYPE_F
    o H5O_TYPE_NTYPES_F
    + C++ API
  - New Wrappers for C Functions H5P[s/g]et_libver_bounds
  - New Wrappers to Get the Object Header's Version
  - New DataType Constructor
    + Support for New Platforms, Languages, and Compilers
  - Support for Linux 3.10.0-123.20.1.el7 added (LK - 2015/04/01)
  * Bug Fixes since HDF5-1.8.14
    + Library
  - Addition of Error Tracing Functionality to Several C API Calls
  - H5Rdereference Now Checks for HADDR_UNDEF or Uninitialized References
  - Fixed Bugs in H5Sextent_copy
    + Parallel Library
  - Fixed a Potential Memory Error
  - Parallel Test Problem Fixed
  - MPE Support
    + Tools
  - h5repack crashed on enumerated 8-bit type.
  - h52gif crashed non-8bit images.
  - perform/benchpar.c retired.
  - Source perform/ directory moved to tools/perform.
    + Fortran API
  - Fortran Fails with --enable-fortran2003 and Intel 15.x Compilers
  - h5tenum_insert_f Does Not Work with Default 8 Byte Integers
    (xlf compiler)
  - Some Fortran APIs Never Returned the Error State
  - Fixed h5pget_class_f
    + C++ API
  - Combined Two H5File::getObjCount Overloaded Methods
    The following two methods
    o ssize_t getObjCount(unsigned types) const;
    o ssize_t getObjCount() const;
    were combined into one:
    o ssize_t getObjCount(unsigned types = H5F_OBJ_ALL) const;
  - Many Warnings Were Removed
  - Functionality Deprecation
    The following two constructors of classes AbstractDs, IdComponent,
    H5Location, and H5Object are no longer appropriate after the data member
    "id" had been moved from IdComponent to the sub-classes in previous
    releases.
    o <Classname>(const hid_t h5_id);
    o <Classname>(const <Classname>& original);
    The copy constructors were no-op and removed in 1.8.15.  The other
    constructors will be removed from 1.10 release, and then from 1.8.17
    if their removal does not cause any problems.
    + High-Level APIs:
  - Suppress Warnings from Flex/Bison-generated Code
  - Changed hdf5_hl.h to Include the HDF5 Main Library "hdf5.h"
  - H5PTcreate_fl Does Not Convert to Memory Datatype
  - Fix for H5LT Attribute Functions
    + Fortran High-Level APIs:
  - Internal Library Fix for Missing Argument Declaration
- Build in thread-safe mode to allow parallel reads
  * These are only unsupported to avoid confusing casual users.
    The fotran and C++ libraries don't support thread-safe mode,
    while the C library does.  So you have to explicitly allow
    building the thread-safe C library and the non-thread-safe C++
    and fortran libraries in order to make sure only people who
    have done their research do so.  Since users are going to be
    accessing this through other programs, this doesn't matter.
- Build fortran 2003 libraries
- Rebase hdf5-non_void_return.patch
- Remove irrelevant hdf5-configure-long-double.patch
* Mon May 11 2015 dmueller@suse.com
- update hdf5-non_void_return.patch for GCC 5.x
* Tue Jan 13 2015 pth@suse.de
- Tag baselibs.conf as source.
* Fri Jan  9 2015 sweet_f_a@gmx.de
- fix typos in ChangeLog
* Wed Nov 19 2014 pgajdos@suse.com
- updated to 1.8.14:
  * bugfix release, see RELEASE.txt
* Mon Jun 23 2014 pgajdos@suse.com
- updated to 1.8.13:
  - Added an H5free_memory API call. This should be used to free memory
    that has been allocated by HDF5 API calls. H5Tget_member_name and
    H5Pget_class_name are two examples. The main motivation for this call
    is Windows, where it is common for application code and the HDF5 Library
    to be using different C run-time libraries (CRT). Using the new call
    ensures that the same CRT handles both the allocation and free. This
    new function can also be useful in any case where the library uses a
    different memory manager than the application, such as when a debug
    memory manager is in use or when the HDF5 Library is wrapped for use
    in a managed language like Python or Java. Fixes HDFFV-7710, 8519,
    and 8851. (DER - 2014/04/11)
  - The Core VFD (aka Memory VFD) can now be configured to track dirty
    regions in the file and only write out the changed regions on
    flush/close. Additionally, a "page aggregation" size can be set that
    will aggregate small writes into larger writes. For example, setting
    a 1 MiB page aggregation size will logically partition the the
    in-memory file into 1 MiB pages that will be written out in their
    entirety if even a single byte is dirtied. The feature is controlled
    via the new H5Pset/get_core_write_tracking() API call. A new
    "core_paged" target has been added to the check-vfd target in
    test/Makefile.am that exercises the feature over all HDF5 VFD-aware
    tests. (DER - 2014/04/12)
  - see http://www.hdfgroup.org/ftp/HDF5/current/src/hdf5-1.8.13-RELEASE.txt
    for more
- modified patches:
  * hdf5-LD_LIBRARY_PATH.patch
* Sun Jan  5 2014 matz@suse.de
- Detect IBM long double specialness on ppc64le and don't segfault
  int the testsuite when checking that type.
  Added patches:
  * hdf5-ldouble-ppc64le.patch
* Tue Nov 26 2013 pgajdos@suse.com
- update to 1.8.12:
  - Added a configuration option to change the default plugin path.
    The configure option is --with-default-plugindir=location.
    The cmake option is -DH5_DEFAULT_PLUGINDIR:PATH=location.
    HDFFV-8513.  (ADB 2013/09/04)
  - Renamed FFLAGS to FCFLAGS in configure. (ADB 2013/08/13)
  - CMake can now package a compressed examples file, the default for
    Windows binaries from HDF Group.  (ADB  - 2013/07/22)
  - h5repack: Added the ability to use plugin filters to read and write
    files. The option uses the filter number. HDFFV-8345
    (ADB - 2013/09/04).
  - h5dump: Added the option -N --any_path, which searches the file for
    paths that match the search path. HDFFV-7989 (ADB - 2013/08/12).
  - h5dump: Added the optional arg 0 to -A, which excludes attributes
    from display. HDFFV-8134 (ADB - 2013/08/01).
  - Added tutorial examples to C++/examples.  They can be installed by
    "make install-examples" and, in the installed directory, they can be
    executed by running the script file run-c++-ex.sh. (BMR - 2013/09/28)
  - A new class, H5::H5Location, is added to represent the location concept
    in the C library.  It is a base class to H5::H5File and H5::H5Ojbect,
    whose member functions are moved into H5::H5Location.  H5::H5File can
    now inherent those functions.  As a result, an H5::H5File object can have
    an attribute. (BMR - 2013/09/27)
  - Added wrappers for H5Rget_obj_type2 to retrieve the type of the object
    that an object reference points to. (BMR - 2013/09/27)
  H5O_type_t H5Location::getRefObjType(void *ref, H5R_type_t ref_type)
  - Added wrappers for H5Aexist to check whether an attribute exists given
    a name. (BMR - 2013/09/27)
  bool H5::H5Location::attrExists(const char* name)
  bool H5::H5Location::attrExists(const H5std_string& name)
  - Added a number of overloaded functions for convenience. (BMR - 2013/09/27)
  - bugfixes
  - see http://www.hdfgroup.org/ftp/HDF5/current/src/hdf5-1.8.12-RELEASE.txt
    for more
* Tue Sep 24 2013 schwab@suse.de
- hdf5-configure-long-double.patch: fix configure check for unsigned long
  long to long double conversion to not fail spuriously for 128bit long
  double
- Increase testsuite timeout for qemu user space build
* Fri Sep 13 2013 pgajdos@suse.com
- build with -O0 also for gcc 4.8
* Fri Jun 14 2013 sweet_f_a@gmx.de
- increase hdf5_libver to 8
* Wed Jun 12 2013 sweet_f_a@gmx.de
- use host config "linux-gnu" for arm (linux-gnueabi) to get useful
  H5_CFLAGS too
- add hdf5-1.8.11-abort_unknown_host_config.patch, to get noticed
  if hdf5 doesn' t know our host
- minimize hdf5-non_void_return.patch, false positives doesn't make
  problems anymore since now we have always -Wmissing-noreturn
- make verbose
- gcc 4.6.x needs -O0 on some systems
* Tue Jun 11 2013 sweet_f_a@gmx.de
- Update to 1.8.11, changes documented here:
  http://www.hdfgroup.org/HDF5/doc/ADGuide/Changes.html
- remove hdf5-fix_printf.patch, fixed by upstream
- use default CFLAGS (-O2) again if possible
* Fri Apr 12 2013 sweet_f_a@gmx.de
- Update to 1.8.10-patch1:
  * official important bug fixes for 1.8.10
  * see RELEASE.txt "Bug Fixes since HDF5-1.8.10"
* Sun Nov 18 2012 sweet_f_a@gmx.de
- Update to 1.8.10, changes documented here:
  http://www.hdfgroup.org/HDF5/doc/ADGuide/Changes.html
- remove hdf5-ph5diff.patch (fixed by upstream)
- add hdf5-fix_printf.patch
* Fri Nov 16 2012 sweet_f_a@gmx.de
- cosmetics, enable parallel build for suse only
- fix build for old findutils
* Mon Nov  5 2012 coolo@suse.com
- fixing baselibs.conf
* Wed Sep 26 2012 sweet_f_a@gmx.de
- make sure to install the examples from non-parallel build
* Mon Sep 24 2012 sweet_f_a@gmx.de
- don't use deprecated macro makeinstall
- enable test suite for parallel builds
- always build out of tree instead of copying sources
* Fri Sep  7 2012 scorot@free.fr
- parallel versions for openmpi and mvapich2
- add baselibs.conf
* Wed Jun 20 2012 sweet_f_a@gmx.de
- minor rpm portability build fixes
  - remove unused source file h5comp
  - enable all tests on ppc again (remove hdf5-1.8.8-tstlite.patch)
  - build fixes for arm
  * avoid some false positives "no-return-in-nonvoid-function"
  * disable some tests on arm only (hdf5-1.8.9-tests-arm.patch)
* Mon May 28 2012 ocefpaf@gmail.com
- Update to 1.8.9
  * Changes documented here:
  http://www.hdfgroup.org/HDF5/doc/ADGuide/Changes.html
* Mon Mar 12 2012 sweet_f_a@gmx.de
- install libhdf5.settings (bnc#751747)
- move executables h5cc and h5c++ to the devel package
* Sun Feb 19 2012 ocefpaf@gmail.com
- Removed "Fixup headers and scripts for multiarch".
* Wed Nov 30 2011 jengelh@medozas.de
- Remove redundant/unwanted tags/section (cf. specfile guidelines)
- Use %%_smp_mflags for parallel building
- Accurate rpmgroup selection for shared library packages
* Tue Nov 29 2011 ocefpaf@gmail.com
- un-commented --with-pthread and --with-ssl.
* Mon Nov 28 2011 ocefpaf@gmail.com
- Update to 1.8.8
  * Add patch to avoid setting LD_LIBRARY_PATH
  * Add patch hdf5-non_void_return.patch
  * Fixed non_void_return (thanks to Boris Manojlovic).
  * Drop tstlite patch
  * drop ppc64 longdouble patch, not required anymore
  * Catch up with some Fedora modifications
  - Add rpm macro %%%%{_hdf5_version} for convenience
  * No Fortran modules for opensuse < 11.4 (Do not pass make check)
  New Features
  ============
    Configuration
  - ------------
  - Added the --enable-fortran2003 flag to enable Fortran2003 support
    in the HDF5 Fortran library. The flag should be used along with the
  - -enable-fortran flag and takes affect only when the Fortran compiler
    is Fortran2003 compliant. (EIP - 2011/11/14)
  - Added checks for clock_gettime and mach/mach_time.h to both configure and
    CMake.  This will support the move from gettimeofday to clock_gettime's
    monotonic timer in the profiling code in a future release.
    (DER - 2011/10/12)
    Library
  - ------
  - The Windows VFD code has been removed with the exception of the functions
    which set it (H5Pset_fapl_windows, for example).  Setting the Windows
    VFD now really sets the SEC2 VFD.  The WINDOWS_MAX_BUF and
    WINDOWS_USE_STDIO configuration options and #defines have also been
    removed. NOTE: Since the Windows VFD was a clone of the SEC2 VFD, this
    change should be transparent to users.
    (DER - 2011/10/12 - HDFFV-7740, HDFFV-7744)
  - H5Tcreate now supports the string type (fixed-length and variable-
    length). (SLU - 2011/05/20)
    Parallel Library
  - ---------------
  - Added new H5Pget_mpio_actual_chunk_opt_mode and
    H5Pget_mpio_actual_io_mode API routines for querying whether/how
    a collective I/O operation completed.  (QAK - 2011/10/12)
    Tools
  - ----
  - None
    High-Level APIs
  - --------------
  - Added the following Fortran wrappers for the Dimension Scale APIs:
    h5dsset_scale_f
    h5dsattach_scale_f
    h5dsdetach_scale_f
    h5dsis_attached_f
    h5dsis_scale_f
    h5dsset_label_f
    h5dsget_label_f
    h5dsget_scale_name_f
    h5dsget_num_scales_f
    (EIP for SB - 2011/10/13 - HDFFV-3797)
    Fortran API
  - ----------
  - The HDF5 Fortran library was enhanced to support the Fortran 2003 standard.
    The following features are available when the HDF5 library is configured
    using the --enable-fortran and --enable-fortran2003 configure flags AND
    if the Fortran compiler is Fortran 2003 compliant:
  - Subroutines overloaded with the C_PTR derived type:
    h5pget_f
    h5pget_fill_value_f
    h5pinsert_f
    h5pregister_f
    h5pset_f
    h5pset_fill_value_f
    h5rcreate_f
    h5rderefrence_f
    h5rget_name_f
    h5rget_obj_type_f
  - Subroutines overloaded with the C_PTR derived type
    and simplified signatures:
    h5aread_f
    h5awrite_f
    h5dread_f
    h5dwrite_f
  - New subroutines
    h5dvlen_reclaim_f
    h5literate_by_name_f
    h5literate_f
    h5ovisit_f
    h5tconvert_f
    h5pset_nbit_f
    h5pset_scaleoffset_f
  - Subroutines with additional optional parameters:
    h5pcreate_class_f
    (EIP - 2011/10/14)
    C++ API
  - ------
  - None
* Thu Jun  2 2011 ocefpaf@yahoo.com.br
- uncomment make check
* Tue May 24 2011 pgajdos@novell.com
- updated to 1.8.7
* Fri Apr 29 2011 pth@suse.de
- undrop package.
- Do type-punning using unions to be able to compile without
  - fno-strict-aliasing.
- Don't use macros in patch names.
- Use _cv_ in variables to be cached by configure.
* Thu May  7 2009 pgajdos@suse.cz
- fixed build with new gcc, see [bnc#501751]
* Mon Mar  2 2009 crrodriguez@suse.de
- save 9MB removing static libraries
* Tue Jan 13 2009 pgajdos@suse.cz
- updated to 1.8.2:
  - Upgraded libtool to version 2.2.6a. (MAM - 2008/10/15).
  - Added two new public routines: H5Pget_elink_fapl() and
    H5Pset_elink_fapl(). (see bug #1247) (VC - 2008/10/13)
  - Improved free space tracking in file to be faster. (QAK - 2008/10/06)
  - Added 'mounted' field to H5G_info_t struct. (QAK - 2008/07/15)
  - h5repack: added new options -u and -b to add a userblock to an HDF5
    file during the repack.  (PVN - 2008/08/26)
  - h5repack: added options -t and -a to call H5Pset_alignment while
    creating a repacked file. (PVN - 2008/08/29)
  - h5ls: added capability to traverse through external links when the -r
    (recursive) flag is given. (NAF - 2008/09/16)
  - h5ls: added -E option to enable traversal of external links.
    h5ls will not traverse external links without this flag being set.
    (NAF - 2008/10/06)
  - h5dump: when -b flag is used without a keyword after it, binary
    output defaults to NATIVE. MEMORY keyword was deprecated
    and replaced by NATIVE keyword. (PVN - 2008/10/30)
  - h5diff: returns 1 when file graphs differ by any object.
    Error return code was changed to 2 from -1.  (PVN - 2008/10/30)
  - h5import: TEXTFPE (scientific format) was deprecated. Use TEXTFP
    instead (PVN - 2008/10/30)
  - Added optional parameter 'mounted' to H5Gget_info_f,
    H5Gget_info_by_idx_f, H5Gget_info_by_name_f (MSB - 2008/09/24)
  - Added H5Tget_native_type_f (MSB - 2008/09/30)
  - These member functions were added as wrapper for H5Rdereference to
    replace the incorrect IdComponent::dereference().
    void H5Object::dereference(H5Object& obj, void* ref,
    H5R_type_t ref_type=H5R_OBJECT)
    void H5Object::dereference(H5File& h5file, void* ref,
    H5R_type_t ref_type=H5R_OBJECT)
    void H5Object::dereference(Attribute& obj, void* ref,
    H5R_type_t ref_type=H5R_OBJECT)
    In addition, these constructors were added to create the associated
    objects by way of dereference:
    DataSet(H5Object& obj, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    DataSet(H5File& file, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    DataSet(Attribute& attr, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    Group(H5Object& obj, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    Group(H5File& obj, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    Group(Attribute& attr, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    DataType(H5Object& obj, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    DataType(H5File& file, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    DataType(Attribute& attr, void* ref, H5R_type_t ref_type=H5R_OBJECT)
    (BMR - 2008/10/29)
- removed destdir.patch
* Mon Jan 12 2009 pgajdos@suse.cz
- fortran modules builds from now [bnc#457593]
* Tue Nov 11 2008 pgajdos@suse.cz
- fixing build of fortran interface moved to the future
* Wed Jul  2 2008 pgajdos@suse.cz
- updated to 1.8.1 [bnc#401626]
  * Enhanced group object management
  * Enhanced attribute management and more efficient meta data handling
  * Expanded datatype features
  * Creation order tracking and indexing
  * Improved meta data caching and cache control
  * UTF-8 encoding
  * New I/O filters: n-bit and scale+offset compression
  * New link (H5L) and object (H5O) interfaces and features
  * External and user-defined links
  * New high-level APIs:
    HDF5 Packet Table (H5PT) and HDF5 Dimension Scale (H5DS)
  * C++ and Fortran interfaces for older high-level APIs:
    H5Lite (H5LT), H5Image (H5IM), and H5Table (H5TB)
  * New and improved tools
- removed doc package (doc/html no longer provided with package)
- octave builds againist 1.6 compatibility stuff
* Wed May  7 2008 pgajdos@suse.cz
- repaired no-return-in-nonvoid-function
  (noreturn.patch)
* Mon Apr 28 2008 pgajdos@suse.cz
- repaired build for
  * ia64 (%%ifarch in hdf5.spec)
  * s390, s390x (s390.patch)
* Tue Mar 25 2008 pgajdos@suse.cz
- package moved from BS, project science
- needed by octave 3.0
